<script setup lang="ts">
  import {
    AggregationProductListingEntities,
    ListingFilter,
    AggregationFilterEntityOption,
  } from '@shopware-pwa/types';
  import { getTranslatedProperty } from '@shopware-pwa/helpers-next';

  const props = defineProps<{
    modelValue?: string[];
    filter: ListingFilter;
  }>();

  const emits = defineEmits<{
    (e: 'update:modelValue', value: string[]): void;
  }>();

  const options = computed(() => {
    return (props.filter.entities || props.filter.options || []).map((option) => {
      return {
        ...option,
        name: getTranslatedProperty(option, 'name'),
      };
    });
  });

  const optionIds = computed(() => {
    const set = new Set();
    options.value.forEach((option) => set.add(option.id));
    return set;
  });

  const selectedOptionIdsCodeBased = computed<string[]>(() => {
    return props.modelValue || [];
  });

  const selectedItemsLabelBased = computed(() => {
    return (options.value as any).filter(
      (option: AggregationProductListingEntities | AggregationFilterEntityOption) =>
        selectedOptionIdsCodeBased.value.includes(option.id),
    );
  });

  const onChange = (ids: string[]) => {
    const selectedIds = selectedOptionIdsCodeBased.value.filter((id) => !optionIds.value.has(id));

    emits('update:modelValue', selectedIds.concat(ids));
  };

  const count = computed(() => {
    return selectedItemsLabelBased.value.length;
  });

  const labelName = computed(() => {
    const countText = count.value ? ` (${count.value})` : '';
    return props.filter.label + countText;
  });

  const modelValues = computed(() => selectedItemsLabelBased.value.map((item: any) => item.id));
</script>

<template>
  <SwSelect
    key-field="id"
    label-field="name"
    :options="options"
    :placeholder="labelName"
    multiple
    size="large"
    :model-value="modelValues"
    @update:model-value="onChange"
  >
    <template #button-text>
      {{ labelName }}
    </template>
  </SwSelect>
</template>
